SystemOrganization addCategory: #GroupManager!
SystemOrganization addCategory: #'GroupManager-Announcements'!

Announcement subclass: #AbstractGroupAnnouncement
	instanceVariableNames: 'group holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!AGroupHasBeenAdded class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 16:32'!
group: aGroup into: anHolder

	^ self group: aGroup from: anHolder! !

AbstractGroupAnnouncement subclass: #AGroupHasBeenCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenRegistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!AGroupHasBeenRegistered class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 13:40'!
with: aGroup

	^ self new group: aGroup! !

!AGroupHasBeenRegistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group

		^ group! !

!AGroupHasBeenRegistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group: anObject
	
		group := anObject! !

AbstractGroupAnnouncement subclass: #AGroupHasBeenRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenRenamed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenUnregistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!AGroupHasBeenUnregistered class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 13:40'!
with: aGroup

	^ self new group: aGroup! !

!AGroupHasBeenUnregistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group

		^ group! !

!AGroupHasBeenUnregistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group: anObject
	
		group := anObject! !

!AbstractGroupAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 22:40'!
group: aGroup

	^ self new 
		group: aGroup;
		yourself! !

!AbstractGroupAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 16:32'!
group: aGroup from: anHolder

	^ self new 
		group: aGroup;
		holder: anHolder;
		yourself! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
group

		^ group! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
group: anObject
	
		group := anObject! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
holder

		^ holder! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
holder: anObject
	
		holder := anObject! !

SystemAnnouncer subclass: #GroupAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!OrderedCollection methodsFor: '*GroupManager' stamp: 'BenjaminVanRyseghem 4/14/2012 12:08'!
removeDuplicates
	| iterator |
	"Remove the copies of elements, but keep the same order"
	
	self ifEmpty: [ ^ self ].
	iterator := 1.
	[ iterator <= self size ]
		whileTrue: [ | each newIndex |
			each := self at: iterator.			
			[ newIndex := (self indexOf: each startingAt: iterator+1).
			newIndex > 0 ]
				whileTrue: [ self removeAt: newIndex ].
			iterator := iterator + 1.
	 ]! !

Object subclass: #AbstractGroup
	instanceVariableNames: 'name readOnly removable sortBlock isFillable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!AbstractGroup commentStamp: '<historical>' prior: 0!
AbstractGroup is an abstraction of what a group is.!

!AbstractGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:06'!
named: aString

	^ self new name: aString! !

!AbstractGroup class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
new

	| instance |
	instance := self basicNew initialize.
	GroupAnnouncer uniqueInstance announce: (AGroupHasBeenCreated group: instance).
	^ instance! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:00'!
beReadOnly

	readOnly := true! !

!AbstractGroup methodsFor: 'polymorphism' stamp: 'BenjaminVanRyseghem 3/28/2011 13:50'!
blocks

	^ { [ self elements ] }! !

!AbstractGroup methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 4/14/2012 12:22'!
classRemoved: anAnnouncement

	self subclassResponsibility! !

!AbstractGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 15:28'!
classes

	^ self subclassResponsibility! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ self subclassResponsibility! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:57'!
ifAllowed: aBlock

	^ self ifAllowed: aBlock ifNot: []! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:57'!
ifAllowed: aBlock ifNot: anotherBlock

	^ self isReadOnly
		ifTrue: anotherBlock
		ifFalse: aBlock! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/14/2012 12:17'!
initialize

	super initialize.
	readOnly := false.
	self registerToAnnouncements.! !

!AbstractGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 17:14'!
isFillable

	^ isFillable ifNil: [ isFillable := false ]! !

!AbstractGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 17:07'!
isFillable: aBoolean

	isFillable := aBoolean! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 21:55'!
isReadOnly

	^ readOnly == true! !

!AbstractGroup methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 4/14/2012 12:22'!
methodModified: anAnnouncement

	self subclassResponsibility! !

!AbstractGroup methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 4/14/2012 12:22'!
methodRemoved: anAnnouncement

	self subclassResponsibility! !

!AbstractGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 15:26'!
methods

	^ self elements! !

!AbstractGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 15:38'!
methodsFor: aClass

	^ self methods select: [:e | e methodClass = aClass ].! !

!AbstractGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 16:57'!
methodsFor: aClass categorised: aSymbol
	
	aSymbol ifNil: [ "all" 
		^ self methodsFor: aClass ].

	^ self methods select: [:e | e methodClass = aClass and: [ e category = aSymbol ]].! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:03'!
name

	^ name! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:04'!
name: aString

	self ifAllowed: [ name := aString ]! !

!AbstractGroup methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 3/29/2011 11:20'!
printOn: aStream

	| className article |
	className := self class name.
	article := className first isVowel
				ifTrue: ['an']
				ifFalse: ['a'].
	aStream
		nextPutAll: article;
		nextPut: Character space;
		nextPutAll: className;
		nextPutAll: ' ( ';
		nextPutAll: self name asString;
		nextPutAll: ' )'.! !

!AbstractGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 15:32'!
protocolsFor: aClass

	^ aClass protocols select: [:e | self methods anySatisfy: [:m | m category = e ]].! !

!AbstractGroup methodsFor: 'announcements registration' stamp: 'BenjaminVanRyseghem 4/14/2012 12:38'!
registerToAnnouncements

	self 
		registerToClassAnnouncements;
		registerToMethodAnnouncements! !

!AbstractGroup methodsFor: 'announcements registration' stamp: 'EstebanLorenzano 8/3/2012 13:57'!
registerToClassAnnouncements

	SystemAnnouncer uniqueInstance weak
		on: ClassRemoved send: #classRemoved: to: self! !

!AbstractGroup methodsFor: 'announcements registration' stamp: 'EstebanLorenzano 8/3/2012 13:57'!
registerToMethodAnnouncements
	
	SystemAnnouncer uniqueInstance weak
		on: MethodModified send: #methodModified: to: self;
		on: MethodRemoved send: #methodRemoved: to: self.! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:41'!
removable

	^ removable ifNil: [ removable := true ]! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:39'!
removable: aBoolean

	removable := aBoolean! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:20'!
sortBlock

	^ sortBlock ifNil: [ sortBlock := [:a :b | a printString <= b printString ]]! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:16'!
sortBlock: aBlock

	sortBlock := aBlock! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 15:32'!
unregister

	GroupsManager unregister: self! !

AbstractGroup subclass: #DynamicGroup
	instanceVariableNames: 'blocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!DynamicGroup commentStamp: '<historical>' prior: 0!
A DynamicGroup is a group automatically updated whose default granularity is method.!

DynamicGroup subclass: #DynamicClassGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!DynamicClassGroup commentStamp: '<historical>' prior: 0!
A DynamicClassGroup is a group automatically updated whose default granularity is class.!

!DynamicClassGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 17:31'!
addClasses: aCollection 
	
	self addBlock: [ aCollection ]! !

!DynamicClassGroup methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 14:42'!
classRemoved: anAnnouncement
	| class |
	
	class := anAnnouncement classRemoved.
	
	blocks copy do: [:b | 
		(b value anySatisfy: [:c | c = class ])
			ifTrue: [ | col |
				col := OrderedCollection new.
				b value do: [:c | c = class
									ifFalse: [ col add: c ]].
				blocks 
					remove: b;
					add: [ col ]]]! !

!DynamicClassGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 16:53'!
classes

	^ (self elements collect: [:e | e theNonMetaClass]) asSet asArray sort: [:a :b | a name < b name ]! !

!DynamicClassGroup methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 4/14/2012 13:31'!
methodModified: anAnnouncement
	"Do not care"! !

!DynamicClassGroup methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 4/14/2012 13:31'!
methodRemoved: anAnnouncement
	"Do not care"! !

!DynamicClassGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 16:17'!
methods

	^ self classes gather: [:e | e methodDict values ]! !

!DynamicClassGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 15:41'!
methodsFor: aClass

	^ aClass methodDict values sort: [:a :b | a selector < b selector ]! !

!DynamicClassGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 16:57'!
methodsFor: aClass categorised: aSymbol

	aSymbol ifNil: [ "all" 
		^ self methodsFor: aClass ].

	^ (aClass methodsInProtocol: aSymbol) sort: [:a :b | a selector < b selector ]! !

!DynamicClassGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 15:41'!
protocolsFor: aClass

	^ aClass protocols sort! !

!DynamicGroup class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
named: aString block: aBlock

	| instance |
	instance := self basicNew
					name: aString;
					block: aBlock;
					initialize;
					yourself.
	GroupAnnouncer uniqueInstance announce: (AGroupHasBeenCreated group: instance).
	^ instance! !

!DynamicGroup class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
named: aString blocks: aCollection

	| instance |
	instance := self basicNew
					name: aString;
					blocks: aCollection;
					initialize;
					yourself.
	GroupAnnouncer uniqueInstance announce: (AGroupHasBeenCreated group: instance).
	^ instance! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2012 12:25'!
addAll: aCollection

	aCollection do: [:e | self addBlock: [{ e }]]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 16:59'!
addBlock: aBlock

	blocks add: aBlock! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 17:35'!
addClasses: aCollection

	aCollection do: [:e |
		self addBlock: [ e theNonMetaClass methodDict values ].
		self addBlock: [ e theMetaClass methodDict values ]]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2012 13:06'!
block: aBlock

	blocks := OrderedCollection with: aBlock! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:14'!
blocks

	^ blocks! !

!DynamicGroup methodsFor: 'accessing' stamp: 'DamienPollet 3/6/2012 19:20'!
blocks: aCollection

	blocks := aCollection! !

!DynamicGroup methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 14:42'!
classRemoved: anAnnouncement
	| class |
	
	class := anAnnouncement classRemoved theNonMetaClass.
	blocks copy do: [:b | (b value anySatisfy: [:e | e methodClass theNonMetaClass = class])
								ifTrue: [ | col |
									col := OrderedCollection new.
									b value do: [:e |
										e methodClass theNonMetaClass = class
											ifFalse: [ col add: e ]].
									blocks 
										remove: b;
										add: [ col ]]].! !

!DynamicGroup methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 2/25/2012 16:52'!
classes

	^ (self methods collect: [:e | e methodClass theNonMetaClass]) asSet asArray sort: [:a :b | a name < b name ]! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2011 16:05'!
elements

	^ (self blocks gather: [:block | block value]) copy asOrderedCollection removeDuplicates! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2012 12:41'!
initialize

	super initialize.
	readOnly := false.
	blocks ifNil: [ blocks := OrderedCollection with: [{}] ]! !

!DynamicGroup methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 13:29'!
methodModified: anAnnouncement
	| method new |
	
	method := anAnnouncement oldMethod.
	new := anAnnouncement newMethod.

	blocks copy do:[: b |
			(b value anySatisfy: [:e | e == method ])
				ifTrue: [ 
					| col |
					col := OrderedCollection new.
					b value do: [:e | 
						e == method
							ifTrue: [ col add: new ]
							ifFalse: [ col add: e ]].
					blocks 
							remove: b;
							add: [ col ]]]! !

!DynamicGroup methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 14:44'!
methodRemoved: anAnnouncement
	| method |
	
	method := anAnnouncement methodAffected.
	blocks copy do:[: b |
			(b value anySatisfy: [:e | e == method ])
				ifTrue: [ 
					| col |
					col := OrderedCollection new.
					b value do: [:e | 
						e == method
							ifFalse: [ col add: e ]].
					blocks 
							remove: b;
							add: [ col ]]]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:48'!
or: aGroup

	| instance |
	instance :=  self class
					named: (self name, ' + ', aGroup name)
					blocks: (self blocks union: aGroup blocks).
	( self isReadOnly or: [ aGroup isReadOnly ]) ifTrue: [ instance beReadOnly ].
	instance removable: ( self removable or: [ aGroup removable ]).
	^ instance! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 17:49'!
removeClass: aClass 

	self blocks copy do: [:b |
		(b value allSatisfy: [:m | m methodClass = aClass theNonMetaClass or: [ m methodClass = aClass theMetaClass ]])
			ifTrue: [ blocks remove: b ]]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 13:14'!
sortBlock: aBlock

	sortBlock := aBlock! !

Object subclass: #GroupsHolder
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsHolder commentStamp: '<historical>' prior: 0!
A GroupsHolder is a simple object which manage a collection of groups!

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/28/2011 14:04'!
add: aCollection into: aGroup

	aGroup
		ifAllowed: [ aGroup addAll: aCollection ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
addADynamicClassGroupNamed: entry block: aBlock 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicClassGroup 
								named: entry 
								block: aBlock).
								
			GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
addADynamicClassGroupNamed: entry blocks: aCollection 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicClassGroup 
								named: entry 
								blocks: aCollection).

			GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 2/27/2012 23:34'!
addADynamicClassGroupSilentlyNamed: entry block: aBlock 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ nil ]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicClassGroup 
								named: entry 
								block: aBlock).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 2/27/2012 23:35'!
addADynamicClassGroupSilentlyNamed: entry blocks: aCollection 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ nil ]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicClassGroup 
								named: entry 
								blocks: aCollection).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
addADynamicGroupNamed: entry block: aBlock 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicGroup 
								named: entry 
								block: aBlock).
								
			GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
addADynamicGroupNamed: entry blocks: aCollection 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicGroup 
								named: entry 
								blocks: aCollection).

			GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 2/27/2012 23:35'!
addADynamicGroupSilentlyNamed: entry block: aBlock 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ nil ]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicGroup 
								named: entry 
								block: aBlock).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 2/27/2012 23:35'!
addADynamicGroupSilentlyNamed: entry blocks: aCollection 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ nil ]
		ifFalse: [ | group |
			group := self groups
						add: 
							(DynamicGroup 
								named: entry 
								blocks: aCollection).
			^ group]! !

!GroupsHolder methodsFor: 'adding' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
addAGroup: aGroup

	(self includesAGroupNamed: aGroup name)
		ifTrue: [ 
			self openError.
			^ nil].
	self groups add: aGroup.
	GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenAdded group: aGroup into: self ).! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 3/2/2012 17:32'!
addAnEmptyDynamicGroupNamed: aName

	^ (self addADynamicGroupNamed: aName block: [ {} ])
			isFillable: true;
			yourself! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 17:24'!
addClasses: aCollection into: aGroup 
	
	aGroup addClasses: aCollection! !

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/21/2011 15:26'!
createADynamicGroup

	| entry aClass aSelector |
	entry := UIManager default textEntry: 'Name of the new group:' title: 'Create a new group' entryText: 'MyNewGroupName'.
	aClass := nil.
	aSelector := nil.
	^ entry ifNotNil: [ self addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector ].! !

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/2/2012 17:16'!
createAnEmptyStaticGroup

	| entry |
	entry := UIManager default request: 'Name of the new group:' initialAnswer: '' title: 'Create a new group'.
	^ (entry isNil or: [entry isEmpty])
		ifFalse: [ self addAnEmptyDynamicGroupNamed: entry ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:40'!
groupNamed: aString

	^ self groups detect: [:each | each name = aString]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:04'!
groups

	^  groups ifNil: [ groups := OrderedCollection new ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:32'!
groupsNames

	^ self groups collect: [:group | group name ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 16:00'!
includes: aGroup

	^ self groups includes: aGroup! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:37'!
includesAGroupNamed: aName

	^ self groupsNames includes: aName! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/21/2011 11:06'!
isEmpty

	^ self groups isEmpty.! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:14'!
openError

	UIManager default alert: 'This group already exists' title: 'Already exists'! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:14'!
openReadOnlyError

	UIManager default  alert: 'This group is read only' title: 'Access error'! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:15'!
openRemoveDialogOn: aGroup

	^UIManager default confirm: ('Dou you really want to delete the group named ', aGroup name)! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 16:58'!
remove: aClass from: aGroup

	^ aGroup
		ifAllowed: [ aGroup remove: aClass ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/28/2011 17:22'!
removeAGroup: aGroup

	| yesIWantToRemoveTheGroup |
	yesIWantToRemoveTheGroup := self openRemoveDialogOn: aGroup.
	yesIWantToRemoveTheGroup
		ifFalse: [ ^ nil ].
	^ self removeAGroupSilently: aGroup
! !

!GroupsHolder methodsFor: 'protocol' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
removeAGroupSilently: aGroup

	| group |
	aGroup ifNil: [ ^ self ].
	 aGroup removable
		ifFalse: [ ^ self openReadOnlyError ].
	group :=  self groups remove: aGroup ifAbsent: [].
	GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenRemoved group: aGroup from: self ).
	^ group! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/1/2012 00:55'!
removeClass: aClass from: aStaticGroup 
	
	^ aStaticGroup
		ifAllowed: [ aStaticGroup removeClass: aClass ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
renameAGroup: aGroup

	| entry |
	entry := UIManager default request: 'New name of the group' initialAnswer: aGroup name title: 'Rename a group'.
	(entry isNil or: [entry isEmpty]) ifTrue: [^ aGroup].
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ self openError ].
	aGroup isReadOnly
		ifTrue: [ ^ self openReadOnlyError ].
	aGroup name: entry.
	GroupAnnouncer uniqueInstance announce: ( AGroupHasBeenRenamed group: aGroup from: self ).
	^ aGroup	
! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:54'!
sort: aBlock

	^ groups := self groups sort: aBlock! !

Object subclass: #GroupsManager
	instanceVariableNames: 'groups'
	classVariableNames: 'CurrentManager'
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsManager commentStamp: '<historical>' prior: 0!
A GroupsManager should be a singleton. It manages all the groups of the system, to be able to share groups among tools!

!GroupsManager class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:08'!
current

	^ CurrentManager ifNil: [ CurrentManager := self new ]! !

!GroupsManager class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:09'!
register: aGroup

	self current register: aGroup! !

!GroupsManager class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:08'!
setCurrentManager: aManager

	CurrentManager := aManager! !

!GroupsManager class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:09'!
unregister: aGroup

	self current unregister: aGroup! !

!GroupsManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/21/2011 16:11'!
initialize

	super initialize.
	groups := OrderedCollection new! !

!GroupsManager methodsFor: 'protocol' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
register: aGroup

	groups add: aGroup.
	GroupAnnouncer uniqueInstance announce: (AGroupHasBeenRegistered with: aGroup)! !

!GroupsManager methodsFor: 'protocol' stamp: 'MarianoMartinezPeck 8/5/2012 15:56'!
unregister: aGroup

	groups remove: aGroup.
	GroupAnnouncer uniqueInstance announce: (AGroupHasBeenUnregistered with: aGroup)! !
